require 'capybara-webkit'
require_relative 'data_extractor'

module Dvla
  module VehicleDetails
    class Scraper
      def initialize(reg, make)
        @reg = reg
        @make = make
      end
      
      def scrape
        c = Capybara::Session.new(:webkit)
        p "Getting page"
        c.visit 'https://www.taxdisc.direct.gov.uk/EvlPortalApp/app/home/intro'

        p 'Clicking Vehicle enquiry'
        c.click_on('Vehicle enquiry')

        p "Clicking Next"
        c.click_on('Next')

        p "Completing form"
        c.fill_in 'vrm', with: @reg
        c.select @make.upcase, from: 'make'
        c.click_on('Submit')

        extractor = DataExtractor.new(c.body)

        {
          car_data: extractor.car_data,
          tax_data: extractor.tax_data
        }
      end
    end
  end
end
